<?php

namespace App\Services\Customer\Wallet;

use App\DTOs\Customer\Wallet\AccountDTO;
use App\Entities\Customer\Wallet\AccountEntity;
use App\Forms\Customer\Wallet\AccountForm;
use App\Helpers\Customer\Wallet\AccountHelper;
use App\Models\Customer\Wallet\AccountModel;
use RuntimeException;

class AccountService extends WalletService
{
    private $_form = null;
    private $_helper = null;
    public function __construct(AccountModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('Account');
    }
    protected function getDTOClass(): string
    {
        return AccountDTO::class;
    }
    public function createDTO(array $formDatas): AccountDTO
    {
        return new AccountDTO($formDatas);
    }
    public function getEntityClass(): string
    {
        return AccountEntity::class;
    }
    public function getFormService(): AccountForm
    {
        if ($this->_form === null) {
            $this->_form = new AccountForm();
            $this->_form->setAttributes([
                'pk_field'         => $this->model->getPKField(),
                'title_field'      => $this->model->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_form;
    }
    public function getHelper(): AccountHelper
    {
        if ($this->_helper === null) {
            $this->_helper = new AccountHelper();
            $this->_helper->setAttributes([
                'pk_field'         => $this->model->getPKField(),
                'title_field'      => $this->model->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_helper;
    }
    public function action_init_process(string $action, array $formDatas = []): void
    {
        $fields = [
            "clientinfo_uid",
            "bank",
            "title",
            "alias",
            "issue_at",
            "amount",
            "status",
            "content"
        ];
        $filters = [
            "clientinfo_uid",
            "bank",
            "status",
        ];
        $indexFilter     = $filters;
        $batchjobFilters = ['bank', 'status'];
        switch ($action) {
            case 'create':
            case 'create_form':
                break;
            case 'modify':
            case 'modify_form':
                $fields = [...$fields, 'status'];
                break;
            case 'view':
                $fields = [...$fields, 'created_at'];
                break;
            case 'index':
            case 'download':
                $fields = [
                    "clientinfo_uid",
                    "bank",
                    "title",
                    "alias",
                    "issue_at",
                    "amount",
                    "status",
                    'created_at',
                ];
                break;
        }
        $this->getFormService()->setFormFields($fields);
        $this->getFormService()->setFormRules($action, $fields);
        $this->getFormService()->setFormFilters($filters);
        $this->getFormService()->setFormOptions($action, $filters, $formDatas);
        $this->getFormService()->setIndexFilters($indexFilter);
        $this->getFormService()->setBatchjobFilters($batchjobFilters);
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): AccountEntity
    {
        return $entity;
    }
    protected function create_process(array $formDatas): AccountEntity
    {
        $entity = parent::create_process($formDatas);
        service('customer_clientservice')->updateBalance($entity->getClientInfoUID(), "예치금", PAYMENT['PAY']['ACCOUNT'], $entity->getAmount(), $entity->getStatus());
        return $entity;
    }
    protected function modify_process($entity, array $formDatas): AccountEntity
    {
        throw new RuntimeException("예치금정보는 수정이 불가합니다.");
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    public function setSearchWord(string $word): void
    {
        $this->model->orLike($this->model->getTable() . '.alias', $word, 'both');
        parent::setSearchWord($word);
    }
}
